package com.ifroglab.ifroglabibeaconapp;



import com.ifroglab.ifroglabibeaconapp.DeviceScanActivity.ViewHolder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


import com.powenko.ifroglab_bt_lib.UartService;
import com.powenko.ifroglab_bt_lib.ifrog;
import com.powenko.ifroglab_bt_lib.ifrog.ifrogCallBack;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.ListActivity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothManager;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

class DeviceAdapter extends BaseAdapter {
    Context context;
    List<BluetoothDevice> devices;
    LayoutInflater inflater;
    Map<String, Integer> devRssiValues;

    Map<String, Date> mDate;

  //  private LayoutInflater mInflator;
    public DeviceAdapter(Context context, List<BluetoothDevice> devices,Map<String, Integer> idevRssiValues) {
        this.context = context;
        inflater = LayoutInflater.from(context);
        this.devices = devices;
        this.devRssiValues=idevRssiValues;

      //  mInflator = this.context.getLayoutInflater();
        mDate = new HashMap<String, Date>();
    }
    
    @Override
    public int getCount() {
        return devices.size();
    }
    
    @Override
    public Object getItem(int position) {
        return devices.get(position);
    }
    
    @Override
    public long getItemId(int position) {
        return position;
    }

    //@Override
    public View getView_old(int position, View convertView, ViewGroup parent) {
        ViewGroup vg;

        if (convertView != null) {
            vg = (ViewGroup) convertView;
        } else {
            vg = (ViewGroup) inflater.inflate(R.layout.device_element, null);
        }

        BluetoothDevice device = devices.get(position);
        final TextView tvadd = ((TextView) vg.findViewById(R.id.address));
        final TextView tvname = ((TextView) vg.findViewById(R.id.name));
        final TextView tvpaired = (TextView) vg.findViewById(R.id.paired);
        final TextView tvrssi = (TextView) vg.findViewById(R.id.rssi);

        tvrssi.setVisibility(View.VISIBLE);
        byte rssival = (byte) devRssiValues.get(device.getAddress()).intValue();
        if (rssival != 0) {
            tvrssi.setText("Rssi = " + String.valueOf(rssival));
        }

        ///////
        tvname.setText(device.getName());
        tvadd.setText(device.getAddress());

            tvname.setTextColor(Color.WHITE);
            tvadd.setTextColor(Color.WHITE);
            tvpaired.setTextColor(Color.GRAY);
            tvpaired.setVisibility(View.VISIBLE);
            tvpaired.setText(R.string.paired);
            tvrssi.setVisibility(View.VISIBLE);
            tvrssi.setTextColor(Color.WHITE);
        
            
        return vg;
    }
    

    @TargetApi(Build.VERSION_CODES.ECLAIR)
    public View getView(int i, View convertView, ViewGroup viewGroup) {
    	/*
    	 ViewHolder viewHolder;
         // General ListView optimization code.
         if (view == null) {
             view = mInflator.inflate(R.layout.listitem_ibeacondevice, null);
         }*/
    	
         ViewGroup view;

         ViewHolder viewHolder;
         if (convertView != null) {
        	 view = (ViewGroup) convertView;

             viewHolder = (ViewHolder) view.getTag();
        	 
         } else {
        	 view = (ViewGroup) inflater.inflate(R.layout.listitem_ibeacondevice, null);
        	 viewHolder = new ViewHolder();
             
             viewHolder.icon = (ImageView) view.findViewById(R.id.icon);
             viewHolder.deviceAddress = (TextView) view.findViewById(R.id.device_address);
             viewHolder.deviceName = (TextView) view.findViewById(R.id.device_name);
             viewHolder.device_rssi = (TextView) view.findViewById(R.id.device_rssi);
             viewHolder.device_date = (TextView) view.findViewById(R.id.device_date);
             
             view.setTag(viewHolder);
             
         }
    
        BluetoothDevice device = devices.get(i);
        final String deviceName = device.getName();
        if (deviceName != null && deviceName.length() > 0)
            viewHolder.deviceName.setText(deviceName);
        else
            viewHolder.deviceName.setText(R.string.unknown_device);
        viewHolder.deviceAddress.setText(device.getAddress());
        String tAddress=device.getAddress();
        Integer tRSSI=devRssiValues.get(tAddress);
        viewHolder.device_rssi.setText("RSSI："+tRSSI.toString());
        
        int t_red=0;
        if(tRSSI<-200){
        	t_red=255;	
        }

        viewHolder.device_rssi.setTextColor(Color.rgb(t_red,0,0));
        

        if(tRSSI<-200){
        	viewHolder.icon.setImageResource(R.drawable.s0);
        }else if(tRSSI<-150){
        	viewHolder.icon.setImageResource(R.drawable.s1);
        }else if(tRSSI<-90){
        	viewHolder.icon.setImageResource(R.drawable.s2);
        }else if(tRSSI<-60){
        	viewHolder.icon.setImageResource(R.drawable.s3);
        }else if(tRSSI<-30){
        	viewHolder.icon.setImageResource(R.drawable.s4);
        }
        
        
        
        
        
       // RSSI (dBm) = -10n log10(d) + A, 
       // 		d: distance in metres 
       // 		A: received signal strength in dBm at 1 meter
       // 		n: propagation constant or path-loss exponent (Free space has n =2 for reference).
        	
        double A= -30.0; // -45.0; // Reference RSSI value at 1 meter
        double n= 2.2; // Path-loss exponent
        double a1=A + tRSSI;
        if (a1<=0){a1=0.00001;}
        double t1=((a1)/(10.0*n));
      // double t2= Math.abs(tRSSI)+A;
        double distance = Math.pow(10.0,t1);
        // 1 mile=160934 centimeter
        String distance2 = String.format("%.5f", distance*160934);
       // String distance2 = String.valueOf(distance);
       // viewHolder.device_rssi.setText("RSSI："+tRSSI.toString()+" 距離："+distance2);
        ///// 時間Get the date today using Calendar object.
        DateFormat df = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
       // Date today=mDate.get(tAddress);
        
        Date today = new Date();
        //System.out.println(dateFormat.format(date));
        
        String reportDate = df.format(today);
        
        Date newerDate= new Date();
        Date olderDate=today;

        long diffInDays = (System.currentTimeMillis()/1000) -(olderDate.getTime()/1000);
        int t_blue=0;
        viewHolder.device_date.setTextColor(Color.rgb(0,0,t_blue));
        if(diffInDays>10){
        	t_blue=255;	
            viewHolder.icon.setImageResource(R.drawable.s0);
        }
        if(diffInDays<5){
        	diffInDays=0;
        }
        viewHolder.device_date.setText("Lastest Time："+reportDate+" 　　offline time:"+String.valueOf(diffInDays));// +" distance:"+distance2 );
        
        return view;
    }


}
