package com.ifroglab.ifroglabibeaconapp;




import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


import com.powenko.ifroglab_bt_lib.UartService;
import com.powenko.ifroglab_bt_lib.ifrog;
import com.powenko.ifroglab_bt_lib.ifrog.ifrogCallBack;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.ListActivity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothManager;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

/**
 * Activity for scanning and displaying available Bluetooth LE devices.
 */
@TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR2)
public class DeviceScanActivity extends Activity  implements  ifrogCallBack {
 //   private LeDeviceListAdapter mLeDeviceListAdapter;
    private BluetoothAdapter mBluetoothAdapter;
    private boolean mScanning;
    private Handler mHandler;
    private static final int REQUEST_ENABLE_BT = 1;
    // Stops scanning after 10 seconds.
   // private static final long SCAN_PERIOD = 10000;
    private static final long SCAN_PERIOD = 10000*600;
    private static final long ReStart_PERIOD = 10000*1;
    private ListView listview;

    private DeviceAdapter deviceAdapter;
    Map<String, Integer> devRssiValues;
    private ifrog mifrog;
    @TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR2)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
       //  getActionBar().setTitle(R.string.title_devices);
        mHandler = new Handler();

        // Use this check to determine whether BLE is supported on the device.  Then you can
        // selectively disable BLE-related features.
        if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE)) {
            Toast.makeText(this, R.string.ble_not_supported, Toast.LENGTH_SHORT).show();
            finish();
        }

        setContentView(R.layout.activity_listviewexampleactivity);
        listview = (ListView) findViewById(R.id.listview);
        final BluetoothManager bluetoothManager = (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
        mBluetoothAdapter = bluetoothManager.getAdapter();
        // Checks if Bluetooth is supported on the device.
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Error!bluetooth not supported", Toast.LENGTH_SHORT).show();
            finish();
            return;
        }
        
        

        service_init();
        mifrog=new ifrog();
        mifrog.setTheListener(this);
        if (mifrog.InitCheckBT(bluetoothManager) == null) {
            Toast.makeText(this, R.string.ble_not_supported, Toast.LENGTH_SHORT).show();
            finish();
            return;
        }
        deviceList = new ArrayList<BluetoothDevice>();
        devRssiValues = new HashMap<String, Integer>();
        deviceAdapter = new DeviceAdapter(this, deviceList,devRssiValues);
        listview.setAdapter(deviceAdapter);
        
        /////////////////
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //getMenuInflater().inflate(R.menu.menu_main, menu);
        
        getMenuInflater().inflate(R.menu.device_scan, menu);
        if (!mScanning) {
            menu.findItem(R.id.menu_stop).setVisible(false);
            menu.findItem(R.id.menu_scan).setVisible(true);
            menu.findItem(R.id.menu_refresh).setActionView(null);
        } else {
            menu.findItem(R.id.menu_stop).setVisible(true);
            menu.findItem(R.id.menu_scan).setVisible(false);
            menu.findItem(R.id.menu_refresh).setActionView(
                    R.layout.actionbar_indeterminate_progress);
        }
        
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menu_scan:
              //  mLeDeviceListAdapter.clear();
                scanLeDevice(true);
                break;
            case R.id.menu_stop:
                scanLeDevice(false);
                break;

            
        }
        return true;
    }

    @TargetApi(Build.VERSION_CODES.ECLAIR)
    @Override
    protected void onResume() {
        super.onResume();
        // Ensures Bluetooth is enabled on the device.  If Bluetooth is not currently enabled,
        // fire an intent to display a dialog asking the user to grant permission to enable it.
        if (!mBluetoothAdapter.isEnabled()) {
            if (!mBluetoothAdapter.isEnabled()) {
                 Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                 startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
                              
            }
        }
        // Initializes list view adapter.
     //   mLeDeviceListAdapter = new LeDeviceListAdapter();
        // listview.setListAdapter(mLeDeviceListAdapter);

     //   listview.setAdapter(mLeDeviceListAdapter);
        scanLeDevice(true);   
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // User chose not to enable Bluetooth.
        if (requestCode == REQUEST_ENABLE_BT && resultCode == Activity.RESULT_CANCELED) {
            finish();
            return;
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    protected void onPause() {
        super.onPause();
        scanLeDevice(false);
     //   mLeDeviceListAdapter.clear();
    }


    // 掃描　BT BLE
    @TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR2)
    private void scanLeDevice(final boolean enable) {
        if (enable) {
            // Stops scanning after a pre-defined scan period.

            mifrog.scanLeDevice(true,SCAN_PERIOD);
          
            mScanning = true;
          //  mBluetoothAdapter.startLeScan(mLeScanCallback);
            
        } else {

            mifrog.scanLeDevice(false,SCAN_PERIOD);
            mScanning = false;
          //  mBluetoothAdapter.stopLeScan(mLeScanCallback);
        }
        invalidateOptionsMenu();
    }

    static class ViewHolder {
    	ImageView icon;
        TextView deviceName;
        TextView deviceAddress;
        TextView device_rssi;
        TextView device_date;
    }
    ////////////

    public static final String TAG = "iFrogLab";
    private UartService mService = null;
    //UART service connected/disconnected
    private ServiceConnection mServiceConnection = new ServiceConnection() {
        public void onServiceConnected(ComponentName className, IBinder rawBinder) {
        	             
        		mService = ((UartService.LocalBinder) rawBinder).getService();
        		Log.d(TAG, "onServiceConnected mService= " + mService);
        		if (!mService.initialize()) {
                    Log.e(TAG, "Unable to initialize Bluetooth");
                    finish();
                }

        }

        public void onServiceDisconnected(ComponentName classname) {
       ////     mService.disconnect(mDevice);
        		mService = null;
        }
    };
    private void service_init() {
    //	this.mifrog.BTService_init(mServiceConnection,UARTStatusChangeReceiver);
        Intent bindIntent = new Intent(this, UartService.class);
        bindService(bindIntent, mServiceConnection, Context.BIND_AUTO_CREATE);
        LocalBroadcastManager.getInstance(this).registerReceiver(UARTStatusChangeReceiver, makeGattUpdateIntentFilter());
    }
    private static IntentFilter makeGattUpdateIntentFilter() {
        final IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction(UartService.ACTION_GATT_CONNECTED);
        intentFilter.addAction(UartService.ACTION_GATT_DISCONNECTED);
        intentFilter.addAction(UartService.ACTION_GATT_SERVICES_DISCOVERED);
        intentFilter.addAction(UartService.ACTION_DATA_AVAILABLE);
        intentFilter.addAction(UartService.DEVICE_DOES_NOT_SUPPORT_UART);
        return intentFilter;
    }
    private final BroadcastReceiver UARTStatusChangeReceiver = new BroadcastReceiver() {

        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();

            final Intent mIntent = intent;
            
        }
    };
    @Override
	public void BTSearchFindDevice(BluetoothDevice device, int rssi,
			byte[] scanRecord) {
    	

		Log.d(TAG, "BTSearchFindDevice, rssi= " + rssi);
		addDevice(device,rssi);
	}

	@Override
	public void BTSearchFindDevicestatus(boolean Scanning) {
		mScanning=Scanning;
		if(mScanning){

            Toast.makeText(this, " Device status Scanning", Toast.LENGTH_SHORT).show();
		} else {

            Toast.makeText(this, " Device status Stop", Toast.LENGTH_SHORT).show();
		}
	}
	
	//////////////

    List<BluetoothDevice> deviceList;
	 private void addDevice(BluetoothDevice device, int rssi) {
	        boolean deviceFound = false;
	        for (BluetoothDevice listDev : deviceList) {
	            if (listDev.getAddress().equals(device.getAddress())) {
	                deviceFound = true;
	                break;
	            }
	        }
	        devRssiValues.put(device.getAddress(), rssi);
	        if (!deviceFound) {
	        	deviceList.add(device);
	        }
	        
	        listview.invalidateViews();
	    }    
	 
}